abstract-deque-0.3: Abstract, parameterized interface to mutable Deques.

Safe Haskell | Safe
Language | Haskell98

Data.Concurrent.Deque.Debugger

Description

This module provides a wrapper around a deque that can enforce additional invariants at runtime for debugging purposes.

Synopsis

- data DebugDeque d elt = DebugDeque (IORef (Maybe ThreadId), IORef (Maybe ThreadId)) (d elt)

# Documentation

data DebugDeque d elt #

Warning, this enforces the excessively STRONG invariant that if any end of the deque is non-threadsafe then it may ever only be touched by one thread during its entire lifetime.

This extreme form of monagamy is easier to verify, because we don't have enough information to know if two operations on different threads are racing with one another or are properly synchronized.

The wrapper data structure has two IORefs to track the last thread that touched the left and right end of the deque, respectively.

Constructors

DebugDeque (IORef (Maybe ThreadId), IORef (Maybe ThreadId)) (d elt) |

Instances

PopL d => PopL (DebugDeque d) # |
Methods tryPopL :: DebugDeque d elt -> IO (Maybe elt) #
DequeClass d => DequeClass (DebugDeque d) # |
Methods newQ :: IO (DebugDeque d elt) # nullQ :: DebugDeque d elt -> IO Bool # pushL :: DebugDeque d elt -> elt -> IO () # tryPopR :: DebugDeque d elt -> IO (Maybe elt) # leftThreadSafe :: DebugDeque d elt -> Bool # rightThreadSafe :: DebugDeque d elt -> Bool #